local ADDONNAME, GrindstoneData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
GrindstoneData.Functions = {}
local Grindstone = GrindstoneData.Functions;
Grindstone.FlyOut = {};
Grindstone.Tooltip = {};
local _;
--Slash Commands
SLASH_Grindstone1, SLASH_Grindstone2 = '/gs', '/Grindstone';	--/Commands
--[VARS] Variables
local _;
local defaults = {
	hold = false,
	showState = "bags",
	Selected = {
		["Source"] = 1,
		["Tier"] = 1,
		["Item"] = 1,
	},
	LOCUS = {					-- Archive the Frame Location
		p			= "CENTER",	-- AnchorPoint
		rp 			= "CENTER",	-- relativePoint
		x 			= 0,		-- xOffset
		y 			= 0			-- yOffset
	}
}
--Text Color Constants
local RarityCommon 		= "|cffffffff";
local RarityUncommon 	= "|cff00ff00";
local pathPrefix		= "Interface\\ICONS\\";
local textureDefault	= "trade_engineering"
local tagNewLine		= "|n"
local VariablesLoaded 	= false;
local FlyOuts 			= {};
local FlyOutButtons 	= {};
local lastTime 			= 0;
local ChartCols 		= {};
local UI_Object 		= {};
local UI_Objects 		= {
[01] = {},
[02] = {},
[03] = {},
};
local holdtabs			= false;
local showState 		= "bags";
-- Text Color Constants
local White  				= "|cffffffff";
local Red    				= "|cffff0000";
local Green  				= "|cff00ff00";
local Blue   				= "|cff6060ff";
local Cyan   				= "|cff00ffff";
local Magenta				= "|cffff00ff";
local Yellow 				= "|cffffff00";

local addonTag			= Green.."Grindstone: "..Cyan
-- Archives

local uberArchive = GrindstoneData.Archive;
local Archive = GrindstoneData.HerbArchive;
local PigmentList = GrindstoneData.PigmentList


local Selected = {
["Source"] = 1,
["Tier"] = 1,
["Item"] = 1,
}
local itemButtons = {}


--[[INITIALIZERS]]--
--[LOAD] Loading Action
function Grindstone_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

--[EVENT] Event Handler
function Grindstone_OnEvent(self, event, ...)
	-- Starts the addon
	if (event == "ADDON_LOADED") then
		local addon = select(1, ...);
		if (addon == "Grindstone") then
			DEFAULT_CHAT_FRAME:AddMessage(Green.."Grindstone "..Red..VERSION..Green..": Loaded.");
			GrindstoneSVPC = GrindstoneSVPC or CopyTable(defaults) -- load our defaults if we have no SV yet (first run)
			Grindstone.Initialize();
		end
		return;
	elseif (event == "PLAYER_ENTERING_WORLD" or event == "UNIT_INVENTORY_CHANGED" or event == "BAG_UPDATE") then --herbs/pigments gained
		Grindstone.Update()
	end
end

function Grindstone.Initialize()
	-- Import saved settings
	local LOCUS = GrindstoneSVPC.LOCUS;
	GrindstoneWidget:SetPoint(LOCUS.p, UIParent, LOCUS.rp, LOCUS.x, LOCUS.y)
	holdtabs = GrindstoneSVPC.hold;
	showState = GrindstoneSVPC.showState;
	Selected["Source"] = GrindstoneSVPC.Selected["Source"]
	Selected["Tier"] = GrindstoneSVPC.Selected["Tier"]
	Selected["Item"] = GrindstoneSVPC.Selected["Item"]
	
	-- Create Main Button Frame
	local uiforge = CreateFrame("Button", "uiforge", GrindstoneWidgetFrame, "HFlyOutButtonTemplate")
	uiforge:SetPoint("CENTER",uiforge:GetParent(),"CENTER",5,0)
	uiforge:Show()
	uiforge.ArrowBtnU.Frame.id = 1
	uiforge.ArrowBtnD.Frame.id = 2
	uiforge.ArrowBtnR.Frame.id = 3
	
	-- Set up Sources tab
	for i = 1, 3 do
		button = CreateFrame("Button", "Btn"..i, uiforge.ArrowBtnU.Frame, "HeimdallIconButtonTemplate")
		button:SetPoint("BOTTOM", button:GetParent(), "BOTTOM", 0, (7+((i-1)*(24+3))))
		button:SetBackdrop({bgFile=(pathPrefix..uberArchive[i].Texture)})
		button:Show()
		button.Text:Hide()
		button.id = i
		table.insert(UI_Objects[01],button)
	end
	
	uiforge:SetBackdrop({bgFile=(pathPrefix..uberArchive[Selected.Source][Selected.Tier][Selected.Item].Texture)})
	uiforge.Text:SetText(GetItemCount(uberArchive[Selected.Source][Selected.Tier][Selected.Item].id))
	Grindstone.Update()
	-- return;
	-- for i = 1, #Archive do
		-- local tier = Archive[i].Tier
		-- if ChartCols[tier] == nil then
			-- local flyOut = CreateFrame("Button", "FlyOut"..i, GrindstoneWidgetFrame, "HeimdallFlyOutTemplate")
			-- table.insert(FlyOuts, flyOut);
			-- table.insert(FlyOutButtons, {});
			-- flyOut.id = tier
			-- ChartCols[tier] = 0
			-- if(tier==1) then
				-- flyOut:SetPoint("TOP", GrindstoneWidgetFrame, "TOP", 0, -7)
			-- else
				-- flyOut:SetPoint("TOP", FlyOuts[tier-1], "BOTTOM", 0, -7)
			-- end
		-- end
		-- ChartCols[tier] = ChartCols[tier] + 1
		-- button = CreateFrame("Button", "Button"..i, FlyOuts[tier], "HeimdallIconButtonTemplate")
		-- button:Show()
		-- button.id = i;
		-- if Archive[i].Texture ~= nil then button:SetBackdrop({bgFile=(pathPrefix..Archive[i].Texture)}); end
		-- Grindstone.FlyOut.AddButton(FlyOuts[tier], button);
		-- table.insert(UI_Object, {Button = button, Texture = texture})
	-- end
	-- GrindstoneWidget:SetHeight((#ChartCols*32)+((#ChartCols+1)*7))
	-- --Grindstone.BagScan()
	-- for i = 1, #ChartCols do
		-- Grindstone.FlyOut.SelectButton(nil, FlyOuts[i]);
	-- end
end

--NEEDS WORK
function Grindstone.Update()
	--Hide all Children of Tier and Item
	local kids = {uiforge.ArrowBtnD.Frame:GetChildren()}
	for _, child in ipairs(kids) do
		child:Hide()
	end
	kids = {uiforge.ArrowBtnR.Frame:GetChildren()}
	for _, child in ipairs(kids) do
		child:Hide()
	end
	--Clear BagScan Archive Entry
	local count = 0
	if Selected.Source == 3 then
		uberArchive[03] = { ["Texture"] = "inv_misc_bag_08", [01] = {["Texture"] = "ability_miling"}, [02] = {["Texture"] = "inv_misc_gem_bloodgem_01"} }
		-- Scan Bags for grindables
		for i = 1, 2 do
			for j = 1, #uberArchive[i] do
				for k = 1, #uberArchive[i][j] do
					if (showState == "grindable" and (GetItemCount(uberArchive[i][j][k].id) >= 5)) 
					or (showState == "bags" and (GetItemCount(uberArchive[i][j][k].id) > 0))
					or (showState == "all") then
						count = count + 1
						uberArchive[03][i][count] = uberArchive[i][j][k]
					end
				end
			end
			count = 0
		end
	end
	-- Populate Tier tab
	local adjust = 0
	for i = 1, #uberArchive[Selected.Source] do
		if UI_Objects[02][i] == nil then
			button = CreateFrame("Button", "Btn"..i, uiforge.ArrowBtnD.Frame, "HeimdallIconButtonTemplate")
			button:SetPoint("TOP", button:GetParent(), "TOP", 0, -(7+((i-1)*(24+4))))
			button.id = i
			UI_Objects[02][i] = button
			--table.insert(UI_Objects[02],button)
		end
		UI_Objects[02][i]:SetBackdrop({bgFile=(pathPrefix..uberArchive[Selected.Source][i].Texture)})
		if Selected.Source == 3 and (#uberArchive[03][i] == 0) then 
			UI_Objects[02][i]:Hide()
			adjust = adjust + 1
		else
			UI_Objects[02][i]:Show()
		end 
		UI_Objects[02][i].Text:Hide()
	end
	uiforge.ArrowBtnD.Frame.BarBKG:SetHeight(2 + ((#uberArchive[Selected.Source] - adjust) * (24 + 4)))
	-- Populate Item Tab
	count = 0 
	local row = 0
	for i = 1, #uberArchive[Selected.Source][Selected.Tier] do
		count = count + 1
		if UI_Objects[03][i] == nil then
			button = CreateFrame("Button", "Btn"..i, uiforge.ArrowBtnR.Frame, "HeimdallIconButtonTemplate")
			button:SetPoint("TOPLEFT", button:GetParent(), "TOPLEFT", (4+((i-1-(floor((count-1)/10)*10))*(24+4))), -4-(24+4)*row)
			button.id = i
			UI_Objects[03][i] = button
			--table.insert(UI_Objects[03],button)
		end
		UI_Objects[03][i]:SetBackdrop({bgFile=(pathPrefix..uberArchive[Selected.Source][Selected.Tier][i].Texture)})
		UI_Objects[03][i].Text:SetText(GetItemCount(uberArchive[Selected.Source][Selected.Tier][i].id))
		UI_Objects[03][i]:Show()
		if count % 10 == 0 then row = row + 1 end 
	end
	-- Adjust BKG if multi-row
	if row ~= 0 then
		if count > 10 then count = 10 end
		local height, width = (8 + (24+4)*(row+1) ),2 + (count * (24 + 4))
		uiforge.ArrowBtnR.Frame.BarBKG:SetWidth(2 + (count * (24 + 4)))
		--uiforge.ArrowBtnR.Frame.BarBKG:SetSize(width, height)
	else
		uiforge.ArrowBtnR.Frame.BarBKG:SetWidth(2 + (#uberArchive[Selected.Source][Selected.Tier] * (24 + 4)))
	end
	-- If no objects to show, else set main button content
	if #uberArchive[Selected.Source] == adjust then 
		print(addonTag.."Nothing to show.")
		uiforge:SetBackdrop({bgFile=(pathPrefix.."inv_misc_questionmark")})
	else
		uiforge:SetBackdrop({bgFile=(pathPrefix..uberArchive[Selected.Source][Selected.Tier][Selected.Item].Texture)})
		uiforge.Text:SetText(GetItemCount(uberArchive[Selected.Source][Selected.Tier][Selected.Item].id))
	end
end

-- function Grindstone.BagScan()
	-- if(lastTime + 1 > time() )then --if run less than 1 second ago
		-- return;
	-- end
	
	-- lastTime = time()
	-- --save frame position
	-- local LOCUS = {}
	-- LOCUS.p, _, LOCUS.rp, LOCUS.x, LOCUS.y = GrindstoneWidget:GetPoint()
	-- GrindstoneSVPC.LOCUS = LOCUS;
	-- local sub, find, len = string.sub, string.find, string.len
	-- for i = 1, #Archive do
		-- local count = GetItemCount(Archive[i].id)
		-- if count >= 1000 then count = string.format("%.1f", floor(count/100) / 10).."K" end
		-- UI_Object[i].Button.Text:SetText(count);
		-- --Check to see if item is active
		-- local flyAttrb = UI_Object[i].Button:GetParent():GetAttribute("macrotext")
		-- if(flyAttrb ~= nil) then flyAttrb = string.sub(flyAttrb, 20) end
		-- if(flyAttrb ~= nil and Archive[i].Name == flyAttrb) then UI_Object[i].Button:GetParent().Text:SetText(count) end
	-- end
-- end

function Grindstone.IndexOf(self)
	return self.id;
	
	--for i = 1, #Archive do
	--	if (self == UI_Object[i].Button) then
	--		return i;
	--	end
	--end
	--return nil
end

--Flyout Arrow Toggle Click
-- Next 3 Handled of in XML
-- function FlyOut_OnClick(self, button)
	-- --local index = Grindstone.FlyOut.GetIndex(self);
	-- --if(index == -1) then
	-- --	self = self:GetParent()
	-- --	index = Grindstone.FlyOut.GetIndex(self);
	-- --end	
	-- local index = self.id;
	-- if(index == nil) then
		-- self = self:GetParent()
		-- index = self.id;
	-- end		
	-- if(self.BarBKG:IsShown()) then
		-- Grindstone.FlyOut.Close(index)
	-- else
		-- Grindstone.FlyOut.Open(index)
	-- end
-- end

-- function Grindstone.FlyOut.Open(index)
	-- local flyOut = FlyOuts[index]
	-- flyOut.CoreBorder:Show()
	-- flyOut.BarBKG:Show()
	-- flyOut.BarCap:Show()
	-- for i = 1, table.getn(FlyOutButtons[index]) do
		-- FlyOutButtons[index][i]:Show()
	-- end
-- end

-- function Grindstone.FlyOut.Close(index)
	-- local flyOut = FlyOuts[index]
	-- flyOut.BarBKG:Hide()
	-- flyOut.BarCap:Hide()
	-- flyOut.CoreBorder:Hide()
	-- for i = 1, table.getn(FlyOutButtons[index]) do
		-- FlyOutButtons[index][i]:Hide()
	-- end
-- end

-- function Grindstone.FlyOut.AddButton(self, button)
	-- --Force Flyout to close
	-- Grindstone.FlyOut.Close(Grindstone.FlyOut.GetIndex(self))
	-- button:Hide();
	-- local wd, ht = self.BarBKG:GetSize();
	-- self.BarBKG:SetSize(wd + 27, ht);
	-- --Get Parent's Index
	-- local parentIndex = Grindstone.FlyOut.GetIndex(self);
	-- button:ClearAllPoints();
	-- local anchorFrame = self;
	-- local offset = 6;
	-- if(table.getn(FlyOutButtons[parentIndex]) ~= 0) then
		-- offset = 3;
		-- anchorFrame = FlyOutButtons[parentIndex][table.getn(FlyOutButtons[parentIndex])];
	-- end
	-- button:SetPoint("LEFT", anchorFrame, "RIGHT", offset, 0);
	-- button:SetFrameLevel(150)
	-- table.insert(FlyOutButtons[parentIndex], button);
	-- --correct the bar background cap from wandering
	-- self.BarCap:SetPoint("TOPLEFT",self.BarBKG, "TOPRIGHT");
-- end

function Grindstone.FlyOut.GetIndex(self)
	--if(self == nil) or (self:GetName() == "GrindstoneWidgetFrame") then return -1; end;
	if self.id ~= nil then return self.id end
	return -1
	--for i = 1, table.getn(FlyOuts) do
		-- if (self == FlyOuts[i]) then 
			-- return i;
		-- end
	-- end
	-- local parentIndex = Grindstone.FlyOut.GetIndex(self:GetParent());
	-- for i = 1, table.getn(FlyOutButtons[parentIndex]) do
		-- if (self == FlyOutButtons[parentIndex][i]) then 
			-- return i;
		-- end
	-- end
	-- return -1;
end

function Grindstone.FlyOut.SelectButton(self, parent)
	
	if ((self == nil) and (parent == nil)) then
		return;
	elseif (self == nil) then 
		self = FlyOutButtons[Grindstone.FlyOut.GetIndex(parent)][1]
	elseif (parent == nil) then
		parent = self:GetParent()
	end
	
	if self:GetParent():GetParent():GetParent():GetName() == "uiforge" then
	local sid, pid = self.id, self:GetParent().id
	if pid ==1 then 
		Selected["Source"] = sid
		Selected["Tier"] = 1
		Selected["Item"] = 1
		uiforge.ArrowBtnD.Frame:Show()
		if not holdtabs then
			uiforge.ArrowBtnU.Frame:Hide()
			uiforge.ArrowBtnR.Frame:Hide()
		end
	elseif pid == 2 then
		Selected["Tier"] = sid
		Selected["Item"] = 1
		uiforge.ArrowBtnR.Frame:Show()
		if not holdtabs then 
			uiforge.ArrowBtnU.Frame:Hide()
			uiforge.ArrowBtnD.Frame:Hide() 
		end
	else
		Selected["Item"] = sid
		if not holdtabs then 
			uiforge.ArrowBtnU.Frame:Hide()
			uiforge.ArrowBtnD.Frame:Hide()
			uiforge.ArrowBtnR.Frame:Hide() 
		end
	end
	GrindstoneSVPC.Selection = Selected;
	Grindstone.Update()
	return
	end
	
	--local index = Grindstone.IndexOf(self);
	parent:SetAttribute("type", "macro")
	--parent:SetAttribute("macrotext", "/cast milling\n/use "..Archive[index].Name)
	parent:SetAttribute("macrotext", "/cast milling\n/use "..Archive[self.id].Name)
	--close FlyOut
	if not holdtabs then Grindstone.FlyOut.Close(Grindstone.FlyOut.GetIndex(parent)) end;
	--Transfer Button Properties
	local bg = self:GetBackdrop()
	local texture = UI_Object[Grindstone.IndexOf(self)].Texture
	
	local text = self.Text:GetText()
	parent.Text:SetText(text)
	parent:SetBackdrop(bg)
end

--NEEDS WORK
function Grindstone.Tooltip.Set(self)
	--local index = self.id --Grindstone.IndexOf(self)
	--GameTooltip:SetItemByID(Archive[index].id)
	if true then
	if self:GetParent().id == 3 then
	GameTooltip:SetItemByID(uberArchive[Selected.Source][Selected.Tier][self.id].id)
	end
	return
	
	end
	
	local bankCount = GetItemCount(Archive[index].id,true)-GetItemCount(Archive[index].id)
	if bankCount ~= 0 then 
		if bankCount >= 1000 then bankCount = string.format("%.1f", floor(count/100) / 10).."K" end
	GameTooltip:AddLine(bankCount.." in Bank")
	end	
	GameTooltip:AddLine("Results:")
	-- List millable results
	for i = 1 , #(Archive[index].Drop) do
		local fontColor = RarityCommon
		if PigmentList[Archive[index].Drop[i]].rarity == "uncommon" then fontColor = RarityUncommon end
		--GameTooltip:AddLine(Archive[index].DropRate[i].."% "..fontColor..PigmentList[Archive[index].Drop[i]].name) -- With drop rate
		GameTooltip:AddLine(fontColor..PigmentList[Archive[index].Drop[i]].name) -- Without drop rate
	end
	GameTooltip:AddLine("Click to select");
	GameTooltip:Show()
end

function Grindstone.MultCmdParse(msg)
	--handle empty msg
	if (msg == "") then
		return "";
	end
	local pos, size, main;
	local sub, find, len = string.sub, string.find, string.len;
	pos = find(msg, " ");
	if (pos == nil) then
		return msg; --handle single param commands
	end
	main = sub(msg, 0, pos - 1);
	size = len(msg);
	msg = sub(msg, pos + 1, size);
	local i = 0;
	local param = {};
	while ((msg ~= "") and (msg ~= " ") and (i < 30)) do
		pos = find(msg, " ");
		if (pos == nil) then
			param[i] = msg;
			break;
		else
			param[i] = sub(msg, 0, pos - 1);
			msg = sub(msg, pos + 1, size);
		end
		i = i + 1;
	end;
	return main, param;
end

function SlashCmdList.Grindstone(msg)
	local param = {};
	msg, param = Grindstone.MultCmdParse(msg);
	local later = Green.."Grindstone:"..Red.." This Command Will Be Active Later";
	if msg == nil or msg == "" then
		print(Green.."Grindstone:"..Cyan.." No Command")
	elseif msg == 'open' then
		-- open flyouts
		if param ~= nil then 
			local tab = tonumber(param[0]) 
			if (tab > 0 and tab <= #ChartCols) then
				print(Green.."Grindstone:"..Cyan.." Opening flyout "..tab..".")
				Grindstone.FlyOut.Open(tab)
			else 
				print(Green.."Grindstone:"..Cyan.." Cannot open flyout "..tab..". Index out of bounds. Use from 1 to "..#ChartCols..".")
				
			end
		else
			print(Green.."Grindstone:"..Cyan.." Opening all flyouts.")
			for i = 1, #ChartCols do
				Grindstone.FlyOut.Open(i)
			end
		end
	elseif msg == "close" then
		-- close all flyouts
		print(addonTag.." Closing all flyouts.")
		for i = 1, #ChartCols do
			Grindstone.FlyOut.Close(i)
		end
	elseif msg == "hold" then
		if holdtabs then
			print(addonTag.."No longer holding tabs open.")
		else
			print(addonTag.."Holding tabs open.")
		end
		holdtabs = not holdtabs
		GrindstoneSVPC.hold = holdtabs
	
	elseif msg == "state" then
		if showState == "all" then
			showState = "bags"
			print(addonTag.."Showing all herbs/ores in bags")
		elseif showState == "bags" then
			showState = "grindable"
			print(addonTag.."Showing only grindable herbs/ores in bags")
		else
			showState = "all"
			print(addonTag.."Showing all herbs/ores")
		end
		
		GrindstoneSVPC.showState = showState
		Grindstone.Update()
	elseif msg == "show" then
		GrindstoneWidget:Show()
	elseif msg == "hide" then
		GrindstoneWidget:Hide()
	end
end

--Add functions to global
_G[ADDONNAME] = Grindstone;